# Graph-To-Structure Example

## System Requirements

* No special hardware required, should run on a laptop (tested on a Macbook Pro2016)
* Prerequisites to install/run the code, usually already installed on most linux machines.

`sudo apt-get install python-pip gfortran libblas-dev liblapack-dev git`


## Installation

To install all Python dependencies, run `python install -r requirements.txt` in the qml-g2s directory.

To compile QMLcode and G2s, execute the following command

`python setup.py install`

For further help on QMLcode visit `https://www.qmlcode.org/installation.html`

Download DGSOl at `https://www.mcs.anl.gov/~more/dgsol/`
To install DGSOL, move into the `dgsol-1.3` directory and follow the instructions provided in the README
to compile the sequential version of DGSOL.


The installation of QML and compilation of DGSOL can take several minutes.


## Demo

The provided `demo` directory contains a jupyter notebook `G2S_example.ipynb` which contains
all the necessary steps to train a G2S model. As example data, 2 `.npy` files are provided which contain
bond order matrices, nuclear charges and distance matrices of 6095 C7O2H10 constitutional isomers from the QM9 database.
The remaining file `geometry.py` contains a Python wrapper to run and parse DGSOL results.


To run the demo, start the juypter-notebook in the demo directory with

`jupyter-notebook G2S_example.ipynb`

and follow the instructions given in the notebook.

As output, the notebook will predict the structures
of C7O2H10 constitutional isomers, of which .xyz files will be written into a directory called `test_geometries`.
The execution of all steps in the notebook should only take minutes on a modern laptop.

## Instructions for use

To use your own data within G2S, you only need
* bond order matrices
* nuclear charges
* full distance matrix
